<template>
  <basic-container>
    <avue-crud :option="option"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.post_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
      <template slot-scope="{row}"
                slot="category">
        <el-tag>{{row.categoryName}}</el-tag>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
import {getList, getDetail, add, update, remove} from "@/api/system/post";
import {mapGetters} from "vuex";

export default {
  data() {
    return {
      form: {},
      query: {},
      loading: true,
      page: {
        pageSize: 10,
        currentPage: 1,
        total: 0
      },
      selectionList: [],
      option: {
        height: 'auto',
        calcHeight: 30,
        tip: false,
        searchShow: true,
        searchMenuSpan: 6,
        border: true,
        index: true,
        viewBtn: true,
        selection: true,
        dialogType: "drawer",
        dialogClickModal: false,
        column: [
          {
            "label": "福利年度",
            "prop": "fuliniandu",
            "type": "year",
            "span": 24,
            "format": "yyyy",
            "valueFormat": "yyyy",
            "display": true,
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "福利年度必须填写"
              }
            ]
          },
          {
            "label": "福利类型",
            "prop": "fulileixing",
            "type": "select",
            "span": 24,
            "dicData": [
              {
                "label": "体检",
                "value": "0"
              },
              {
                "label": "疗养",
                "value": "1"
              },
            ],
            "display": true,
            "props": {
              "label": "label",
              "value": "value",
              "desc": "desc"
            },
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "福利类型必须填写"
              }
            ]
          },
          {
            "label": "开始日期",
            "prop": "kaishiriqi",
            "type": "date",
            "span": 12,
            "format": "yyyy-MM-dd",
            "valueFormat": "yyyy-MM-dd",
            "display": true,
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "开始日期必须填写"
              }
            ]
          },
          {
            "label": "结束日期",
            "prop": "jieshuriqi",
            "type": "date",
            "span": 12,
            "format": "yyyy-MM-dd",
            "valueFormat": "yyyy-MM-dd",
            "display": true,
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "结束日期必须填写"
              }
            ]
          },
          {
            "label": "总名额",
            "prop": "zongminge",
            "type": "input",
            "span": 24,
            "display": true,
            "labelWidth": 100,
            "hide":true,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "总名额必须填写"
              }
            ]
          },
          {
            "label": "面向对象",
            "prop": "mianxiangduixiang",
            "type": "select",
            "span": 24,
            "hide":true,

            "dicData": [
              {
                "label": "全体员工",
                "value": "0"
              },
              {
                "label": "副局级以上",
                "value": "1"
              },
              {
                "label": "副处级以上",
                "value": "2"
              }
            ],
            "display": true,
            "props": {
              "label": "label",
              "value": "value",
              "desc": "desc"
            },
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "面向对象必须填写"
              }
            ]
          },
          {
            "label": "报名情况",
            "prop": "baomingqingkuang",
            "type": "input",
            "span": 24,
            "display": false,
            "labelWidth": 100,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "总名额必须填写"
              }
            ]
          },
          {
            "label": "地点",
            "prop": "didian",
            "type": "input",
            "span": 24,
            "display": true,
            "labelWidth": 100,
            "required": true,
            "hide":true,

            "rules": [
              {
                "required": true,
                "message": "地点必须填写"
              }
            ]
          },
          {
            "label": "地址",
            "prop": "dizhi",
            "type": "input",
            "span": 24,
            "display": true,
            "labelWidth": 100,
            "hide":true,

            "required": true,
            "rules": [
              {
                "required": true,
                "message": "地址必须填写"
              }
            ]
          },
          {
            "label": "现场联系人",
            "prop": "xianchanglianxiren",
            "type": "input",
            "span": 24,
            "display": true,
            "labelWidth": 100,
            "hide":true,

            "required": true,
            "rules": [
              {
                "required": true,
                "message": "现场联系人必须填写"
              }
            ]
          },
          {
            "label": "电话",
            "prop": "dianhua",
            "type": "input",
            "span": 24,
            "display": true,
            "labelWidth": 100,
            "hide":true,
            "required": true,
            "rules": [
              {
                "required": true,
                "message": "电话必须填写"
              }
            ]
          },
        ]
      },
      data: [
        {
          fuliniandu: '2022',
          fulileixing:'体检',
          kaishiriqi: '2022-07-10',
          jieshuriqi: '2022-07-20',
          zongminge:'550',
          mianxiangduixiang:'全体员工',
          baomingqingkuang:'10/550',
          didian:'爱康国宾',
          dizhi:'上海市徐汇区虹桥路333号3033',
          xianchanglianxiren:'王医生',
          dianhua:'18611111111',
        },
        {
          fuliniandu: '2022',
          fulileixing:'疗养',
          kaishiriqi: '2022-08-10',
          jieshuriqi: '2022-08-20',
          zongminge:'20',
          mianxiangduixiang:'副处级以上',
          baomingqingkuang:'10/20',
          didian:'第一疗养院',
          dizhi:'上海市徐汇区虹桥路222号',
          xianchanglianxiren:'王主管',
          dianhua:'18622222222',
        }
      ]
    };
  },
  computed: {
    ...mapGetters(["permission"]),
    permissionList() {
      return {
        addBtn: this.vaildData(this.permission.post_add, false),
        viewBtn: this.vaildData(this.permission.post_view, false),
        delBtn: this.vaildData(this.permission.post_delete, false),
        editBtn: this.vaildData(this.permission.post_edit, false)
      };
    },
    ids() {
      let ids = [];
      this.selectionList.forEach(ele => {
        ids.push(ele.id);
      });
      return ids.join(",");
    }
  },
  methods: {
    rowSave(row, done, loading) {
      add(row).then(() => {
        this.onLoad(this.page);
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        done();
      }, error => {
        window.console.log(error);
        loading();
      });
    },
    rowUpdate(row, index, done, loading) {
      update(row).then(() => {
        this.onLoad(this.page);
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        done();
      }, error => {
        window.console.log(error);
        loading();
      });
    },
    rowDel(row) {
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          return remove(row.id);
        })
        .then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
        });
    },
    handleDelete() {
      if (this.selectionList.length === 0) {
        this.$message.warning("请选择至少一条数据");
        return;
      }
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          return remove(this.ids);
        })
        .then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          this.$refs.crud.toggleSelection();
        });
    },
    beforeOpen(done, type) {
      if (["edit", "view"].includes(type)) {
        getDetail(this.form.id).then(res => {
          this.form = res.data.data;
        });
      }
      done();
    },
    searchReset() {
      this.query = {};
      this.onLoad(this.page);
    },
    searchChange(params, done) {
      this.query = params;
      this.page.currentPage = 1;
      this.onLoad(this.page, params);
      done();
    },
    selectionChange(list) {
      this.selectionList = list;
    },
    selectionClear() {
      this.selectionList = [];
      this.$refs.crud.toggleSelection();
    },
    currentChange(currentPage) {
      this.page.currentPage = currentPage;
    },
    sizeChange(pageSize) {
      this.page.pageSize = pageSize;
    },
    refreshChange() {
      this.onLoad(this.page, this.query);
    },
    onLoad(page, params = {}) {
      this.loading = true;
      getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
        const data = res.data.data;
        this.page.total = data.total;
        this.data = data.records;
        this.loading = false;
        this.selectionClear();
      });
    }
  }
};
</script>

<style>
</style>
